<?php

/************************************************************************************/
/*														*/
/*					   Menu : Configwitcher						*/
/*					  ----------------------					*/
/*					     configwitcher.php						*/
/*					  ----------------------					*/
/*														*/
/*	Date				: 19 Mars 2012							*/
/*	Copyright			: 2012 PhpCraft (C)						*/
/*	Email				: phpcraft@live.fr						*/
/*	Version			: Menu Configwitcher v.1.0.0					*/
/*														*/
/*	Compatible			: PhpBoost v.3.0							*/
/*														*/
/************************************************************************************/
/*														*/
/*	This program is free software; you can redistribute it and/or modify it 	*/
/*	under the terms of the GNU General Public License as published by the Free 	*/
/*	Software Foundation; either version 2 of the License, or (at your option) 	*/
/*	any later version.										*/
/*														*/
/*	This program is distributed in the hope that it will be useful, but WITHOUT	*/
/*	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS */
/*	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details	*/
/*														*/
/*	You should have received a copy of the GNU General Public License	along with	*/
/*	this program; if not, write to the Free Software Foundation, Inc., 		*/
/*	51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.			*/
/*														*/
/************************************************************************************/

/************************************************************************************/
/*														*/
/*	$Id: configwitcher.php (*_*) Version : 1.0.0 - 19/03/2012 14:24 $phpcraft	*/
/*														*/
/************************************************************************************/

function menu_configwitcher_configwitcher($position, $block)
{
	global $CONFIG, $LANGS_CONFIG, $THEME_CONFIG, $User, $LANG, $Session;

	// ------------------------------
	// Chargement du fichier language
	//
	load_menu_lang('configwitcher');

	// -------------------------
	// Configuration du language
	//
	$switchlang = !empty($_GET['switchlang']) ? urldecode($_GET['switchlang']) : '';
	if ( !empty($switchlang) )
	{
		if ($User->check_level(MEMBER_LEVEL))
		{
			$Session->csrf_get_protect();
		}

		if ( preg_match('`[ a-z0-9_-]{3,20}`i', $switchlang) && strpos($switchlang, '\'') === false )
		{
			// Mise  jour du language de l'utilisateur
			$User->update_user_lang($switchlang);
			if (QUERY_STRING != '')
			{
				$query_string = preg_replace('`token=[^&]+`', '', QUERY_STRING);
				$query_string = preg_replace('`&switchlang=[^&]+`', '', $query_string);
				redirect(trim(HOST . SCRIPT . (!empty($query_string) ? '?' . $query_string : '')));
			}
			else
			{
				redirect(HOST . SCRIPT);
			}
		}
	}

	// ----------------------
	// Configuration du thme
	//
	$switchtheme = !empty($_GET['switchtheme']) ? urldecode($_GET['switchtheme']) : '';
	if ( !empty($switchtheme) )
	{
		if ($User->check_level(MEMBER_LEVEL))
		{
			$Session->csrf_get_protect();
		}

		if ( preg_match('`[ a-z0-9_-]{3,20}`i', $switchtheme) && strpos($switchtheme, '\'') === false )
		{
			// Mise  jour du thme de l'utilisateur
			$User->update_user_theme($switchtheme);
			if (QUERY_STRING != '')
			{
				redirect(trim(HOST . SCRIPT . '?' . preg_replace('`switchtheme=[^&]+`', '', QUERY_STRING), '?'));
			}
			else
			{
				redirect(HOST . SCRIPT);
			}
		}
	}

	// -------------------------
	// Chargement du fichier TPL
	//
	$tpl = new Template('menus/configwitcher/configwitcher.tpl');

	// -------------------------
	// Importation du block menu
	//
	import('core/menu_service');
	MenuService::assign_positions_conditions($tpl, $block);

	// ---------------------
	// Slection du language
	//
	$array_js_identifier = '';
	$ulang = get_ulang();
	foreach($LANGS_CONFIG as $lang => $array_info)
	{
		if ($User->check_level($array_info['secure']))
		{
			$info_lang = load_ini_file('../lang/', $lang);
			$selected = ($ulang == $lang) ? ' selected="selected"' : '';

			// ---------------
			// Variable du TPL
			//
			$tpl->assign_block_vars('langs', array(
				'NAME' => $info_lang['name'],
				'IDNAME' => $lang,
				'SELECTED' => $selected
			));
		}
	}
	$lang_identifier = str_replace('en', 'uk', $LANG['xml_lang']);

	// ------------------
	// Slection du thme
	//
	$utheme = get_utheme();
	ksort($THEME_CONFIG);
	foreach($THEME_CONFIG as $theme => $array_info)
	{
		if ($User->check_level($array_info['secure']) && $theme != 'default')
		{
			$info_theme = @parse_ini_file(PATH_TO_ROOT . '/templates/' . $theme . '/config/' . get_ulang() . '/config.ini');
			$selected = ($utheme == $theme) ? ' selected="selected"' : '';

			// ---------------
			// Variable du TPL
			//
			$tpl->assign_block_vars('themes', array(
				'NAME' => $info_theme['name'],
				'IDNAME' => $theme,
				'SELECTED' => $selected
			));
		}
	}

	// ---------------
	// Variable du TPL
	//
	$tpl->assign_vars(array(
		'L_SWITCH_CONFIG' => $LANG['switch_config'],

		'L_SWITCH_LANG' => $LANG['switch_lang'],
		'L_LANG_IDENTIFIER' => $ulang,
		'L_DEFAULT_LANG' => $LANG['default_lang'],
		'L_SUBMIT' => $LANG['submit'],

		'L_SWITCH_THEME' => $LANG['switch_theme'],
		'L_THEME_IDENTIFIER' => $utheme,
		'L_DEFAULT_THEME' => $LANG['default_theme'],
		'L_SUBMIT' => $LANG['submit'],

		'IMG_LANG_IDENTIFIER' => PATH_TO_ROOT . '/images/stats/countries/' . $lang_identifier . '.png',
		'DEFAULT_LANG' => $CONFIG['lang'],

		'IMG_THEME_IDENTIFIER' => PATH_TO_ROOT . '/templates/' . $utheme . '/theme/images/theme.jpg',
		'DEFAULT_THEME' => $CONFIG['theme']
	));
	return $tpl->parse(TEMPLATE_STRING_MODE);
}

//
// Fin du fichier !
// ----------------

?>